;	Clock device driver Ver 1.00 for PC-1480U, specified to RTC-72421
;
;	Copyright (c) 1992 - 1999 N.Kon, 1999 ArsLab
;
;
		pre_on
;
		org	$bf000
;----------------------------------------
;		const
;----------------------------------------
rtc_hour:	equ	$1005
rtc_year:	equ	$100b
rtc_day:	equ	$100c
;
iocsfook:	equ	$bfca2
iocs_entry:	equ	$fffe8
base:		equ	$ec
bx:		equ	$d4
bl:		equ	$d4
bh:		equ	$d5
cx:		equ	$d6
cl:		equ	$d6
ch:		equ	$d7
dx:		equ	$d8
dl:		equ	$d8
dh:		equ	$d9
si:		equ	$da
di:		equ	$dd
;----------------------------------------
;		install
;----------------------------------------
		mv	il,0
;
		mv	x,device_name
		callf	iocs_entry
		jrc	install
		mv	(cx),0
		mv	il,$b
		mv	x,err_msg
		mv	y,install - err_msg
		callf	iocs_entry
		rc
		retf
device_name:	db	'CLOCK:',0
err_msg:	db	'"CLOCK:" was already installed.',13,10
install:	mv	(cx),0
		mv	x,iocsfook
		mv	x,[x]
		inc	x
install_2:	dec	x
		mv	a,[x+3]
		cmp	(cx),a
		jrnc	install_1
		mv	(cx),a
install_1:	mv	x,[x]
		inc	x
		jrnz	install_2
search_end:	inc	(cx)
		mv	[device_number],(cx)
		mv	(cl),6
		mv	(ch),0
		mv	i,$47
		callf	$fffe8
;
		pmdf	($ec),$f0
		mv	x,[$bfc15]
		mv	y,[x+$12]
		add	x,y
		mv	(bp),x
;
init_1:		mv	a,[x]
		cmp	a,$ff
		jrz	block_end
		mv	a,[x+12];
		test	a,$c
		jrz	set_start
		mv	y,[x+$11]
		add	x,y;
		jr	init_1
set_start:	mv	(bp),x
init_2:		mv	a,[x]
		cmp	a,$ff
		jrz	block_end
		mv	y,[x+$11]
		add	x,y;
		jr	init_2
block_end:	mv	(bp+3),x
		mv	y,[$bfcde]
		dec	y
		sub	y,x
		mv	(bp+6),y
		mv	y,block_bottom - block_top
		cmpp	(bp+6),y
		jrc	exit
;
;
		mv	x,[iocsfook]
		mv	[header],x
		mv	x,(bp)
		mv	il,$22
		add	x,il
		mv	[iocsfook],x
;
		mv	x,modify_table
init_3:		mv	y,[x++]
		inc	y
		jrz	modify_end
		pushu	x
		mv	x,[y]
		pushu	y
		mv	y,block_top
		sub	x,y
		mv	y,(bp)
		add	x,y
		popu	y
		mv	[y],x
		popu	x
		jr	init_3
modify_end:
;
		mv	x,(bp+3)
		mv	y,(bp)
		sub	x,y
		mv	(bp+6),x
		mv	x,(bp+3)
		mv	y,x
		mv	ba,block_bottom - block_top
		add	y,ba
		inc	x
		inc	y
;
init_6:		mv	a,[--x]
		mv	[--y],a
		mv	a,(bp+6)
		sub	a,1
		mv	(bp+6),a
		jrnc	init_6
		mv	a,(bp+7)
		sub	a,1
		mv	(bp+7),a
		jrnc	init_6
		mv	a,(bp+8)
		sub	a,1
		mv	(bp+8),a
		jrnc	init_6
;
		mv	i,block_bottom - block_top
		mv	y,(bp)
		mv	x,block_top
init_5:		mv	a,[x++]
		mv	[y++],a
		dec	i
		jrnz	init_5
;
exit:		mv	x,[$ffffd]
		jp	x
;----------------------------------------
;		file_header
;----------------------------------------
block_top:	db	$fb,'CLOCK   SYS'
		db	$25
		dw	0,0
		dp	block_bottom - block_top
		dw	0
		dp	block_bottom - block_top
		dp	block_bottom - block_top
		dp	0,0
;----------------------------------------
;		_header
;----------------------------------------
header:		ds	3
;
device_number:	db	11
		db	$00
;
mod01:		dp	entry
		db	'CLOCK:',0
;----------------------------------------
;		substance
;----------------------------------------
entry:		mv	(di+2),a
		mv	ba,i
		cmp	a,$3f
		jrc	error
;
cmd3f_40:	cmp	a,$41
		jrnc	cmd41
;
		rc
		retf
;
cmd41:		jrnz	cmd42
		mv	a,(si)
		mv	i,1900
		add	i,a
		mv	ba,i
		rc
		ex	a,b
		shr	a
		ex	a,b
		shr	a
		rc
		ex	a,b
		shr	a
		ex	a,b
		shr	a
		add	i,ba
		mv	a,(si+1)
mod02:		mv	x,table - 1
		add	x,a
		mv	a,[x]
		add	i,a
		mv	a,(si)
		and	a,3
		jrnz	cmd41_01
		cmp	(si+1),3
		jrnc	cmd41_01
		dec	i
cmd41_01:	mv	a,(si+2)
		add	i,a
		mv	a,7
cmd41_02:	sub	i,a
		jrnc	cmd41_02
		add	i,a
		mv	[rtc_day],il
		mv	x,rtc_year
mod03:		jpf	set_dt
;
cmd42:		cmp	a,$42
		jrnz	cmd43
		mv	x,rtc_year
mod04:		jpf	get_dt
;
cmd43:		cmp	a,$43
		jrnz	cmd44
		mv	x,rtc_hour
mod05:		jpf	set_dt
;
cmd44:		cmp	a,$44
		jrnz	error
		mv	x,rtc_hour
mod06:		jpf	get_dt
;
error:		sc
		retf
;
set_dt:		mv	a,0
mod09:		callf	set_dt_sub
		mv	a,(si+2)
mod10:		callf	bin2bcd
		mv	[x-5],a
		mv	[x-4],il
		rc
		retf
;
set_dt_sub:	mv	a,(si)
mod11:		callf	bin2bcd
		mv	[x-1],a
		mv	[x],il
		mv	a,(si+1)
mod12:		callf	bin2bcd
		mv	[x-3],a
		mv	[x-2],il
		rc
		retf
;
get_dt:		mv	a,0
mod13:		callf	get_dt_sub
		mv	a,[x-5]
		mv	il,[x-4]
mod14:		callf	bcd2bin
		mv	(si+2),a
		mv	(di),[rtc_day]
		and	(di),7
		rc
		retf
;
get_dt_sub:	mv	a,[x-1]
		mv	il,[x]
mod15:		callf	bcd2bin
		mv	(si),a
		mv	a,[x-3]
		mv	il,[x-2]
mod16:		callf	bcd2bin
		mv	(si+1),a
		rc
		retf
;
bin2bcd:	mv	il,0
bin2bcd_0:	inc	il
		sub	a,10
		jrnc	bin2bcd_0
		dec	il
		add	a,10
		retf
;
bcd2bin:	and	a,15
		ex	ba,i
		and	a,15
		ex	ba,i
		test	(di+2),1
		jrz	bcd2bin_0
		ex	ba,i
		swap	a
		add	a,il
		retf
bcd2bin_0:	add	il,il
		add	a,il
		add	il,il
		add	il,il
		add	a,il
		retf
;
table:		db	5,1,1,4,6,2,4,0,3,5,1,3
;
block_bottom:
;----------------------------------------
;		modify table
;----------------------------------------
modify_table:	dp	mod01-1,mod02,mod03,mod04,mod05,mod06,mod09,mod10
		dp	mod11,mod12,mod13,mod14,mod15,mod16
		dp	-1
;
		end
